@ECHO OFF
if "%1"=="/dev_list" goto device_list
cd|set /p TOPDIR=
set MVF=mvf.exe
set UBOOTNAME=LOADER
set FWNAMECODE=PROGRAM0
set FWNAMEDATA=DSRAM
set IMG=image
set PROGNAME=%0
set BOARD=hba
set DEV_LIST=
set OPTS=
set bfile=
if "%1"=="" goto endloop
:loop
if "%1"=="-h" goto help
if "%1"=="-help" goto help
if "%1"=="" goto endloop
if "%1"=="-e" set OPTS=%OPTS% %1
if "%1"=="-e" goto next
if "%1"=="-a" set OPTS=%OPTS% %1
if "%1"=="-a" goto next
if "%1"=="-y" set OPTS=%OPTS% %1
if "%1"=="-y" goto next
if "%1"=="-b" set OPTS=%OPTS% %1 %2
if "%1"=="-b" goto option_on
if "%1"=="-x" set OPTS=%OPTS% %1
if "%1"=="-x" goto next
if "%1"=="-w" set OPTS=%OPTS% %1
if "%1"=="-w" goto next
if "%1"=="-v" set OPTS=%OPTS% %1
if "%1"=="-v" goto next
if "%1"=="-d" set OPTS=%OPTS% %1
if "%1"=="-d" goto next
if "%1"=="-u" set OPTS=%OPTS% %1
if "%1"=="-u" goto next
if "%1"=="-n" set OPTS=%OPTS% %1
if "%1"=="-n" goto next

if "%bfile%"=="1" goto next
goto fail_command

:option_on
set bfile=1
goto next

:option_off
set bfile=
goto next

:next
shift
goto loop

:endloop
cd bin
set DEV_ID=
%MVF% -l > 1
sed -ne "s/DevId: *\([0-9a-zA-Z]*\).*/set DEV_LIST=%%DEV_LIST%% \1\n/p" 1 > dev_list.bat
call dev_list.bat
call ..\go.bat /dev_list %DEV_LIST%
del dev_list.bat
del 1
cd ..
goto end

:device_list
shift
set DEV_ID=%1
if "%1"=="" goto fail_end
goto %DEV_ID%_ID

:6122_ID
:6145_ID
:6440_ID
:6480_ID
:8480_ID
:8180_ID
:0000_ID
REM MAGNI ID
:9011_ID
:9020_ID
:9022_ID
:9110_ID
:9111_ID
:9120_ID
:9122_ID
:9125_ID
:9023_ID
:9123_ID
:914A_ID
:914B_ID
:914C_ID
:914D_ID
:914E_ID
:914F_ID
:90A3_ID
:9190_ID
:9191_ID
:91A0_ID
:91A3_ID
:91A5_ID
:914D_ID
:91A4_ID
:9128_ID
:91A8_ID
:9028_ID
REM for recovery
:91CD_ID
goto device_list

REM VILI ID
:8120_ID
:8110_ID
REM PLATO ID
:9143_ID
:9141_ID
goto DO_FLASH

:evb
REM set UBOOTADDR=0x70000
REM set UBOOTCS=3
ReM set LOKIADDR=0x200000
REM set LOKICS=1
goto DO_FLASH

:hba
set UBOOTADDR=0xFFFF0000
set UBOOTCS=3
set BIOSADDR=0x38000
set LOKIADDRCODE=0x10000
set VILIIMGADDR=0x10000
set LOKIADDRDATA=0x20000
set LOKICS=3
goto DO_FLASH

:DO_FLASH
CLS
echo.
echo.
echo     ************************************************************
echo     *  Warning! Plato requires Autoload to function properly.  *
echo     *  Please make sure to follow the instructions.            *
echo     *  Failure to do so could disable the Plato board.         *
echo     *  DO NOT power cycle in the middle of flashing.           *
echo     ************************************************************
echo.
PAUSE
CLS
echo -----------------------------------------------------------------
echo                         MARVELL FLASH TOOL
echo -----------------------------------------------------------------
:DO_FL1
call mvm.bat %IMG% %DEV_ID% %VILIIMGADDR% -newImg %OPTS%
goto end

:erase
if "%BOARD%"=="" goto help
echo erase for %BOARD%...
goto erase%BOARD%
goto end

:eraseevb
%MVF% -e -did %DEV_ID% -cs 1

:erasehba
%MVF% -e -did %DEV_ID% -cs 3
goto end

REM Do help screen
:help
echo ------------------------------------------------------------------
echo                       MARVELL FLASH TOOL HELP
echo ------------------------------------------------------------------
echo type 'go'                  Update PLATO Firmware
echo type 'go -y'               Update PLATO Firmware with Yes included
REM Have split screen
if "%OPTS%"=="-v" goto detailed
shift
if "%1"=="-v" goto detailed
echo type 'go -h'               Display simple help screen (this screen)
goto end
:detailed
echo type 'go -h -v'            Display detailed help screen (this screen)
echo type 'go -e'               Erase every sector
echo type 'go -a'               Flash only autoload
echo type 'go -b'               Flash only BIOS on PLATO
echo type 'go -b [filename]'    Flash specific file as BIOS
echo type 'go -b [filename] -u' Flash specific file as BIOS to UMI
echo type 'go -b [filename] -n' Flash specific file as BIOS to NVMHCI
echo type 'go -b -e'            Erase only BIOS
echo type 'go -x'               Flash only Firmware on PLATO
echo type 'go -x -e'            Erase only Firmware on PLATO
echo type 'go -d'               Erase HBA partition
echo type 'go -v'               Show verbose message
goto end

:fail_end
echo Did not find device! Check connection.
goto end

:fail_command
echo Bad Command.  Please check with help!
goto end

:end
set PROGNAME=
set BOARD=
set NORAID=
set OPTS=
set ERASE=
set LOKICS=
set LOKIADDR=
set UBOOTCS=
set UBOOTADDR=
set MVF=
set FWNAME=
set IMAGE=